C********0*********0*********0*********0*********0*********0*********0
C   SVD decomposition using LAPACK routine for complex 4x4 matrix.
C********0*********0*********0*********0*********0*********0*********0
       SUBROUTINE svdexpmat(udatlog,cmat,uout,vout,sing)
       IMPLICIT none
       INTEGER udatlog
       COMPLEX*16 cmat(4,4), uout(4,4), vout(4,4)
       DOUBLE PRECISION sing(4)

C      ...local declarations
       CHARACTER*1 jobu, jobvt 
       INTEGER mrows, ncols, lda, ldu, ldvt
       INTEGER lwork
       COMPLEX*16 cmat1(4,4), u(4,4), vt(4,4)
       COMPLEX*16 work(20)         !...of dimension lwork
       DOUBLE PRECISION rwork(20)  !...of dimension 5*4
       INTEGER i,j,info
      
C      ...perform SVD of matrix mmat using LAPACK library routine
       jobu='S'        !...left hand singular vectors required
       jobvt='S'       !...right hand signular vectors required
C      ...matrix dimensions
       mrows=4
       ncols=4
C      ...declared maximum array dimensions
       lda=4
       ldu=4
       ldvt=4
       lwork=20

C      ...copy matrix over because this call overwrites
       do i=1,4
         do j=1,4
           cmat1(i,j)=cmat(i,j)
         enddo
       enddo

       CALL ZGESVD(jobu,jobvt,mrows,ncols,cmat1,lda,sing,u,ldu,vt,ldvt,
     &             work,lwork,rwork,info)

       if (info.ne.0) then
         write(udatlog,*) '...ERROR in SVD routine. "info"=', info
         stop
       endif

C      ...process U and V into forms consistent with my definition
C      ..."u" is my "vout", "vt" is the complex conjugate transpose of my "uout"
       do i=1,4
         do j=1,4
           vout(i,j)=u(i,j)
           uout(i,j)=dconjg(vt(j,i))
         enddo
       enddo

       RETURN
       END

